"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }// src/list-markdown.ts
var listMarkdownPlugin = (md, _options) => {
  md.core.ruler.after("inline", "bangle-list-kind-attrs", (state) => {
    const tokens = state.tokens;
    let currentListKind = null;
    for (let i = 0; i < tokens.length; i++) {
      const token = tokens[i];
      if (isBulletListOpen(token)) {
        currentListKind = "bullet";
        _optionalChain([token, 'optionalAccess', _ => _.attrSet, 'call', _2 => _2("data-bangle-list-kind", "bullet")]);
      } else if (isOrderedListOpen(token)) {
        currentListKind = "ordered";
        _optionalChain([token, 'optionalAccess', _3 => _3.attrSet, 'call', _4 => _4("data-bangle-list-kind", "ordered")]);
      } else if (_optionalChain([token, 'optionalAccess', _5 => _5.type]) === "bullet_list_close" || _optionalChain([token, 'optionalAccess', _6 => _6.type]) === "ordered_list_close") {
        currentListKind = null;
      } else if (_optionalChain([token, 'optionalAccess', _7 => _7.type]) === "list_item_open" && currentListKind) {
        if (!token.attrGet("data-bangle-list-kind")) {
          token.attrSet("data-bangle-list-kind", currentListKind);
        }
      }
    }
    return false;
  });
  md.core.ruler.after("inline", "bangle-task-lists", (state) => {
    const tokens = state.tokens;
    for (let i = 2; i < tokens.length; i++) {
      if (isTodoItem(tokens, i)) {
        convertToTaskItem(tokens, i);
      }
    }
    return false;
  });
  const originalRenderToken = md.renderer.renderToken.bind(md.renderer);
  md.renderer.renderToken = (tokens, idx, options) => {
    const token = tokens[idx];
    if (_optionalChain([token, 'optionalAccess', _8 => _8.type]) === "list_item_open") {
      const kindAttr = _optionalChain([token, 'optionalAccess', _9 => _9.attrGet, 'call', _10 => _10("data-bangle-list-kind")]);
      if (kindAttr === "task") {
        const checkedAttr = token.attrGet("data-bangle-task-checked") || "false";
        token.attrSet("data-bangle-task-checked", checkedAttr);
      }
    }
    return originalRenderToken(tokens, idx, options);
  };
};
function isOrderedListOpen(token) {
  return _optionalChain([token, 'optionalAccess', _11 => _11.type]) === "ordered_list_open";
}
function isBulletListOpen(token) {
  return _optionalChain([token, 'optionalAccess', _12 => _12.type]) === "bullet_list_open";
}
function isTodoItem(tokens, index) {
  return isInline(tokens[index]) && isParagraphOpen(tokens[index - 1]) && isListItemOpen(tokens[index - 2]) && startsWithTodoMarkdown(_optionalChain([tokens, 'access', _13 => _13[index], 'optionalAccess', _14 => _14.content]));
}
function startsWithTodoMarkdown(content) {
  if (!content) return false;
  const prefix = content.slice(0, 4).toLowerCase();
  return prefix === "[ ] " || prefix === "[x] ";
}
function convertToTaskItem(tokens, index) {
  const listItemOpen = tokens[index - 2];
  const inlineToken = tokens[index];
  if (!listItemOpen || !inlineToken || !inlineToken.children) return;
  listItemOpen.attrSet("data-bangle-list-kind", "task");
  const firstChild = inlineToken.children[0];
  if (_optionalChain([firstChild, 'optionalAccess', _15 => _15.type]) === "text") {
    const text = firstChild.content;
    const isChecked = _optionalChain([text, 'access', _16 => _16[1], 'optionalAccess', _17 => _17.toLowerCase, 'call', _18 => _18()]) === "x";
    listItemOpen.attrSet(
      "data-bangle-task-checked",
      isChecked ? "true" : "false"
    );
    if (text.startsWith("[ ] ") || text.startsWith("[x] ") || text.startsWith("[X] ")) {
      firstChild.content = text.slice(4);
    }
  }
}
function isInline(token) {
  return _optionalChain([token, 'optionalAccess', _19 => _19.type]) === "inline";
}
function isParagraphOpen(token) {
  return _optionalChain([token, 'optionalAccess', _20 => _20.type]) === "paragraph_open";
}
function isListItemOpen(token) {
  return _optionalChain([token, 'optionalAccess', _21 => _21.type]) === "list_item_open";
}



exports.listMarkdownPlugin = listMarkdownPlugin;
