"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }


var _chunk5YKPDWE5cjs = require('./chunk-5YKPDWE5.cjs');


var _chunk3JDIDZDScjs = require('./chunk-3JDIDZDS.cjs');

// src/markdown.ts
function createTokenCollection(type) {
  return {
    type,
    parsing: {},
    toMarkdown: {}
  };
}
function processTokens(collection, key, value, type) {
  const parse = value.parseMarkdown;
  if (parse) {
    for (const [key2, value2] of Object.entries(parse)) {
      if (collection.parsing[key2]) {
        throw new Error(`Duplicate ${type} parsing token found: ${key2}`);
      }
      collection.parsing[key2] = value2;
    }
  }
  const toMarkdown = value.toMarkdown;
  if (toMarkdown) {
    if (collection.toMarkdown[key]) {
      throw new Error(`Duplicate ${type} toMarkdown token found: ${key}`);
    }
    collection.toMarkdown[key] = toMarkdown;
  }
}
function markdownLoader(items, schema, tokenizers = _chunk3JDIDZDScjs.defaultTokenizers, serializerOptions) {
  const nodeTokens = createTokenCollection("node");
  const markTokens = createTokenCollection("mark");
  for (const item of items) {
    if (_optionalChain([item, 'access', _ => _.markdown, 'optionalAccess', _2 => _2.nodes])) {
      for (const [key, value] of Object.entries(item.markdown.nodes)) {
        processTokens(nodeTokens, key, value, "node");
      }
    }
    if (_optionalChain([item, 'access', _3 => _3.markdown, 'optionalAccess', _4 => _4.marks])) {
      for (const [key, value] of Object.entries(item.markdown.marks)) {
        processTokens(markTokens, key, value, "mark");
      }
    }
  }
  for (const key of Object.keys(nodeTokens.parsing)) {
    if (markTokens.parsing[key]) {
      throw new Error(
        `Token key "${key}" exists in both nodes and marks parsing tokens`
      );
    }
  }
  return {
    parser: new (0, _chunk5YKPDWE5cjs.MarkdownParser)(schema, tokenizers, {
      ...nodeTokens.parsing,
      ...markTokens.parsing
    }),
    serializer: new (0, _chunk5YKPDWE5cjs.MarkdownSerializer)(
      nodeTokens.toMarkdown,
      markTokens.toMarkdown,
      serializerOptions
    )
  };
}



exports.markdownLoader = markdownLoader;
